package live04;

/**
 * Tutkitaan alkulukuja
 * @author vesal
 * @version 19.1.2021
 *
 */
public class Alkuluku {
    
    /**
     * Aliohjelmalla tutkitaan onko parametrina tuotu
     * luku alkuluku vai ei<br>
     * Algoritmi: Jaetaan tutkittavaa lukua jakajilla 2,3,5,7...luku/2.
     * Jos jokin jako menee tasan, niin ei alkuluku.
     * @param luku tutkittava luku
     * @return 1 jos alkuluku muuten millä jaollinen
     * @example
     * <pre name="test">
     *   millaJaollinen(2) === 1;
     *   millaJaollinen(4) === 2;
     *   millaJaollinen(25) === 5;
     *   millaJaollinen(123) === 3;
     *   millaJaollinen(7)   === 1;
     * </pre>
     */
    public static int millaJaollinen(int luku) {
        int jakaja = 2;
        int kasvutus = 1;
        if (luku == 2) return 1;              // 0
        do {
            int jakojaannos = luku % jakaja;
            if (jakojaannos == 0) return jakaja;  // 1
            jakaja += kasvutus;                   // 2
            kasvutus = 2;                         // 3
        } while (jakaja < luku/2);                // 4
        return 1;
    }
    

    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        int luku = 25;
        int jaollinen;
        
        jaollinen = millaJaollinen(luku);
        if ( jaollinen == 1)
            System.out.println("alkuluku");
        else
            System.out.println("Jaollinen luvulla " + jaollinen);
    }

}
