/**
 * 
 */
package testaaminen;

/**
 * @author vesal
 * @version 1.2.2021
 *
 */
public class Poista {

    /**
     * POistaa jonosta kakikki poistettavien esiintymät
     * @param jono mistä poistetaan
     * @param poistettava mitä poistetaan
     * @return jono jossa ei ole yhtään poistettava-jonon esiintymää
     * @example
     * <pre name="test">
     *   poista("Catcat"   ,"at")  ===  "Cc";
     *   poista("Paatti"   ,"at")  ===  "Pi";
     *   poista("Puatit"   ,"at")  ===  "Puit";
     *   poista("Abba"     ,"bb")  ===  "Aa";
     *   poista("Abbababba","ba")  ===  "Abb";
     *   poista("AbbabaaB" ,"ba")  ===  "AB";
     *   poista("Abba"     ,"Ab")  ===  "ba";
     *   poista("Abba"     ,"cc")  ===  "Abba";
     *   poista("Abba"     ,""  )  ===  "Abba";
     *   poista(""         ,"Aa")  ===  "";
     *   poista(""         ,""  )  ===  "";
     *   poista(null       ,""  )  ===  "";
     *   poista(null       ,"k"  ) ===  "";  //  # THROWS NullPointerException
     *   poista("Kissa"    ,null)  ===  "Kissa";
     * </pre>
     */
    public static String poista(String jono, String poistettava) {
        String tulos = demo.d3.Poista.poista(jono, poistettava);
        return tulos;
    }


    private static int poistatesti(String jono, String mita, String odotettuTulos) {
        String vaihdettu = poista(jono, mita);
        if (vaihdettu.equals(odotettuTulos)) return 0;
        System.out.println(jono + " => " + vaihdettu + " piti tulla " + odotettuTulos);
        return 1;
    }
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        int v = 0;
        v += poistatesti("Catcat", "at", "Cc");
        v += poistatesti("Paatti", "at", "Pi");
        v += poistatesti("Putti", "at", "Puti");
        v += poistatesti("Abba", "bb", "Aa");
        System.out.println("Virheitä oli " + v);
    }
}
