package taulukot;
import java.util.Arrays;
/**
 * Esimerkki testaamisesta taulukkonotaatiolla
 * @author vesal
 * @version 1.3.2021
 */
public class Testaaminen2 {
    /**
     * Alustetaan taulukko juoksevasti
     * @param t alustettava taulukko, taulukon sisältö muuttuu
     * @param alku ensimmäisen alkion arvo
     * @param askel ero seuraavaan alkioon
     * @return viite alustettuun taulukkoon
     // BYCODEBEGIN
     * @example
     * <pre name="test">
     * #import java.util.Arrays;
     *    Arrays.toString(alusta(new int[$koko],$alku,$askel)) === "$tulos";
     *    
     *        $koko | $alku | $askel | $tulos
     *     ----------------------------------------------------
     *         5    |  3    |   5    | [3, 8, 13, 18, 23]         
     *         0    |  1    |   1    | []         
     *         1    |  1    |   1    | [1]         
     *         3    |  1    |  -1    | [1, 0, -1]         
     * </pre>
     // BYCODEEND
     */
    public static int[] alusta(int t[], int alku, int askel) {
        int arvo = alku;
        for (int i=0; i<t.length; i++, arvo += askel ) t[i] = arvo;
        return t;
    }

    
    /** @param args ei käytössä   */
    public static void main(String[] args) {
        int[] t = new int[6];
        alusta(t,1,2);
        System.out.println(Arrays.toString(t));
    }
}

