package kerho.test;
// Generated by ComTest BEGIN
import java.util.*;
import java.io.*;
import static org.junit.Assert.*;
import org.junit.*;
import kerho.*;
// Generated by ComTest END

/**
 * Test class made by ComTest
 * @version 2019.01.06 23:47:13 // Generated by ComTest
 *
 */
public class KerhoTest {



  // Generated by ComTest BEGIN
  /** 
   * testLisaa37 
   * @throws SailoException when error
   */
  @Test
  public void testLisaa37() throws SailoException {    // Kerho: 37
    Kerho kerho = new Kerho(); 
    Jasen aku1 = new Jasen(), aku2 = new Jasen(); 
    kerho.lisaa(aku1); 
    kerho.lisaa(aku2); 
    kerho.lisaa(aku1); 
    Collection<Jasen> loytyneet = kerho.etsi("",-1); 
    Iterator<Jasen> it = loytyneet.iterator(); 
    assertEquals("From: Kerho line: 46", aku1, it.next()); 
    assertEquals("From: Kerho line: 47", aku2, it.next()); 
    assertEquals("From: Kerho line: 48", aku1, it.next()); 
  } // Generated by ComTest END


  // Generated by ComTest BEGIN
  /** 
   * testAnnaHarrastukset84 
   * @throws SailoException when error
   */
  @Test
  public void testAnnaHarrastukset84() throws SailoException {    // Kerho: 84
    Kerho kerho = new Kerho(); 
    Jasen aku1 = new Jasen(), aku2 = new Jasen(), aku3 = new Jasen(); 
    aku1.rekisteroi(); aku2.rekisteroi(); aku3.rekisteroi(); 
    int id1 = aku1.getTunnusNro(); 
    int id2 = aku2.getTunnusNro(); 
    Harrastus pitsi11 = new Harrastus(id1); kerho.lisaa(pitsi11); 
    Harrastus pitsi12 = new Harrastus(id1); kerho.lisaa(pitsi12); 
    Harrastus pitsi21 = new Harrastus(id2); kerho.lisaa(pitsi21); 
    Harrastus pitsi22 = new Harrastus(id2); kerho.lisaa(pitsi22); 
    Harrastus pitsi23 = new Harrastus(id2); kerho.lisaa(pitsi23); 
    List<Harrastus> loytyneet; 
    loytyneet = kerho.annaHarrastukset(aku3); 
    assertEquals("From: Kerho line: 101", 0, loytyneet.size()); 
    loytyneet = kerho.annaHarrastukset(aku1); 
    assertEquals("From: Kerho line: 103", 2, loytyneet.size()); 
    assertEquals("From: Kerho line: 104", true, loytyneet.get(0) == pitsi11); 
    assertEquals("From: Kerho line: 105", true, loytyneet.get(1) == pitsi12); 
    loytyneet = kerho.annaHarrastukset(aku2); 
    assertEquals("From: Kerho line: 107", 3, loytyneet.size()); 
    assertEquals("From: Kerho line: 108", true, loytyneet.get(0) == pitsi21); 
  } // Generated by ComTest END


  // Generated by ComTest BEGIN
  /** 
   * testLueTiedostosta137 
   * @throws SailoException when error
   */
  @Test
  public void testLueTiedostosta137() throws SailoException {    // Kerho: 137
    Kerho kerho = new Kerho(); 
    Jasen aku1 = new Jasen(); aku1.vastaaAkuAnkka(); aku1.rekisteroi(); 
    Jasen aku2 = new Jasen(); aku2.vastaaAkuAnkka(); aku2.rekisteroi(); 
    Harrastus pitsi21 = new Harrastus(); pitsi21.vastaaPitsinNyplays(aku2.getTunnusNro()); 
    Harrastus pitsi11 = new Harrastus(); pitsi11.vastaaPitsinNyplays(aku1.getTunnusNro()); 
    Harrastus pitsi22 = new Harrastus(); pitsi22.vastaaPitsinNyplays(aku2.getTunnusNro()); 
    Harrastus pitsi12 = new Harrastus(); pitsi12.vastaaPitsinNyplays(aku1.getTunnusNro()); 
    Harrastus pitsi23 = new Harrastus(); pitsi23.vastaaPitsinNyplays(aku2.getTunnusNro()); 
    String hakemisto = "testikelmit"; 
    File dir = new File(hakemisto); 
    File ftied  = new File(hakemisto+"/nimet.dat"); 
    File fhtied = new File(hakemisto+"/harrastukset.dat"); 
    dir.mkdir(); 
    ftied.delete(); 
    fhtied.delete(); 
    try {
    kerho.lueTiedostosta(hakemisto); 
    fail("Kerho: 159 Did not throw SailoException");
    } catch(SailoException _e_){ _e_.getMessage(); }
    kerho.lisaa(aku1); 
    kerho.lisaa(aku2); 
    kerho.lisaa(pitsi21); 
    kerho.lisaa(pitsi11); 
    kerho.lisaa(pitsi22); 
    kerho.lisaa(pitsi12); 
    kerho.lisaa(pitsi23); 
    kerho.tallenna(); 
    kerho = new Kerho(); 
    kerho.lueTiedostosta(hakemisto); 
    Collection<Jasen> kaikki = kerho.etsi("",-1); 
    Iterator<Jasen> it = kaikki.iterator(); 
    assertEquals("From: Kerho line: 172", aku1, it.next()); 
    assertEquals("From: Kerho line: 173", aku2, it.next()); 
    assertEquals("From: Kerho line: 174", false, it.hasNext()); 
    List<Harrastus> loytyneet = kerho.annaHarrastukset(aku1); 
    Iterator<Harrastus> ih = loytyneet.iterator(); 
    assertEquals("From: Kerho line: 177", pitsi11, ih.next()); 
    assertEquals("From: Kerho line: 178", pitsi12, ih.next()); 
    assertEquals("From: Kerho line: 179", false, ih.hasNext()); 
    loytyneet = kerho.annaHarrastukset(aku2); 
    ih = loytyneet.iterator(); 
    assertEquals("From: Kerho line: 182", pitsi21, ih.next()); 
    assertEquals("From: Kerho line: 183", pitsi22, ih.next()); 
    assertEquals("From: Kerho line: 184", pitsi23, ih.next()); 
    assertEquals("From: Kerho line: 185", false, ih.hasNext()); 
    kerho.lisaa(aku2); 
    kerho.lisaa(pitsi23); 
    kerho.tallenna(); 
    assertEquals("From: Kerho line: 189", true, ftied.delete()); 
    assertEquals("From: Kerho line: 190", true, fhtied.delete()); 
    File fbak = new File(hakemisto+"/nimet.bak"); 
    File fhbak = new File(hakemisto+"/harrastukset.bak"); 
    assertEquals("From: Kerho line: 193", true, fbak.delete()); 
    assertEquals("From: Kerho line: 194", true, fhbak.delete()); 
    assertEquals("From: Kerho line: 195", true, dir.delete()); 
  } // Generated by ComTest END
}