/**
 * 
 */
package guiMalli2Kerho;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JSplitPane;
import java.awt.Dimension;
import javax.swing.JTextArea;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JScrollPane;

/**
 * Yksinkertaistettu malli käyttöliittymästä
 * @author vesal
 * @version 24.2.2011
 */
public class KerhoGUI extends JFrame {

    private static final long serialVersionUID = 1L;
    private JPanel contentPane;
    private final JPanel panelNappulat = new JPanel();
    private final JButton buttonLisaa = new JButton("Lis\u00E4\u00E4");
    private final JButton btnTulosta = new JButton("Tulosta");
    private final JSplitPane splitPane = new JSplitPane();
    private final JPanel panelJasen = new JPanel();
    private final JPanel panelKaikkiJasenet = new JPanel();
    private final JTextArea textJasen = new JTextArea();
    /**
     * @wbp.nonvisual location=110,351
     */
    private final KerhoSwing kerhoSwing = new KerhoSwing(this);
    private final JScrollPane scrollPane = new JScrollPane();
    private final JTextArea textArea = new JTextArea();
    
    
    /**
     * @return tekstialue johon saa kirjoittaa
     */
    public JTextArea getTextJasenet() {
        return textArea;
    }


    /**
     * @return tekstialue johon saa kirjoittaa
     */
    public JTextArea getTextJasen() {
        return textJasen;
    }


    private final JPanel panel = new JPanel();


    /**
     * Launch the application.
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    KerhoGUI frame = new KerhoGUI();
                    frame.setVisible(true);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }


    /**
     * Create the frame.
     */
    public KerhoGUI() {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 450, 300);
        contentPane = new JPanel();
        contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
        contentPane.setLayout(new BorderLayout(0, 0));
        setContentPane(contentPane);
        
        contentPane.add(panelNappulat, BorderLayout.SOUTH);
        buttonLisaa.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                getKerhoSwing().uusiJasen();
            }
        });
        
        panelNappulat.add(buttonLisaa);
        btnTulosta.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent arg0) {
                getKerhoSwing().tulostaJasenet();
            }
        });
        
        panelNappulat.add(btnTulosta);
        
        contentPane.add(splitPane, BorderLayout.CENTER);
        panelJasen.setPreferredSize(new Dimension(200, 10));
        
        splitPane.setLeftComponent(panelJasen);
        panelJasen.setLayout(new BorderLayout(0, 0));
        
        panelJasen.add(textJasen);
        
        splitPane.setRightComponent(panelKaikkiJasenet);
        panelKaikkiJasenet.setLayout(new BorderLayout(0, 0));
        
        panelKaikkiJasenet.add(scrollPane, BorderLayout.CENTER);
        
        scrollPane.setViewportView(panel);
        panel.setLayout(new BorderLayout(0, 0));
        panel.add(textArea);
    }


    /**
     * @return viite käytössä olevaan KerhoSwingiin
     */
    protected KerhoSwing getKerhoSwing() {
        return kerhoSwing;
    }

}