package luento15;

/**
 * Tutkitaan jonoksi-funktion suorituskykyä
 * @author vesal
 * @version 25.2.2018
 *
 */
public class Jonoksi {

    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna. 
     * Lopussa ei ylimääräistä erotinta.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @param tila monenko merkin tila kullekin numerolle varataan.
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi(t,",",1) === "1,2,13,4";   
     *   jonoksi(t,",",2) === " 1, 2,13, 4";   
     * </pre>
     */
    public static String jonoksi(int[] taulukko,String erotin,int tila) {
        StringBuilder tulos = new StringBuilder();
        String format = String.format("%%s%%%dd", tila); // esim. %s%2d
        String ero = "";
        for (int  luku : taulukko) {
            tulos.append(String.format(format,ero,luku));
            ero = erotin;
        }
        return tulos.toString();
    }
    
    
    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna. 
     * Lopussa ei ylimääräistä erotinta.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi(t,",") === "1,2,13,4";   
     * </pre>
     */
    public static String jonoksi(int[] taulukko,String erotin) {
        var tulos = new StringBuilder();
        String ero = "";
        for (int  luku : taulukko) {
            tulos.append(ero);
            tulos.append(luku);
            ero = erotin;
        }
        return tulos.toString();
    }
    

    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna. 
     * Lopussa ei ylimääräistä erotinta.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi2(t,",") === "1,2,13,4";   
     * </pre>
     */
    public static String jonoksi2(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        String ero = "";
        for (int  luku : taulukko) {
            tulos.append(ero + luku);
            ero = erotin;
        }
        return tulos.toString();
    }
    

    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna. 
     * Lopussa ei ylimääräistä erotinta.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi3(t,",") === "1,2,13,4";   
     * </pre>
     */
    public static String jonoksi3(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        for (int  i=0; i<taulukko.length; i++) {
            if ( i > 0 ) tulos.append(erotin);
            tulos.append(taulukko[i]);
        }
        return tulos.toString();
    }
    

    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna. 
     * Lopussa ei ylimääräistä erotinta.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi4(t,",") === "1,2,13,4";   
     *   jonoksi4(new int[0],",") === "";   
     * </pre>
     */
    public static String jonoksi4(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        if ( taulukko.length == 0 ) return "";
        for (int  i=0; i<taulukko.length; i++) {
            tulos.append(erotin);
            tulos.append(taulukko[i]);
        }
        return tulos.substring(erotin.length());
    }
    

    /**
     * Palautetaan taulukko merkkijonona erottimella eroteltuna. 
     * Lopussa ei ylimääräistä erotinta.
     * @param taulukko joka palautetaan jonona
     * @param erotin millä jonolla erotellaan
     * @return taulukko merkkijonona erottimella eroteltuna
     * @example
     * <pre name="test">
     *   int[] t = {1,2,13,4};
     *   jonoksi5(t,",") === "1,2,13,4";   
     * </pre>
     */
    public static String jonoksi5(int[] taulukko,String erotin) {
        StringBuilder tulos = new StringBuilder();
        if ( taulukko.length == 0 ) return "";
        for (int luku: taulukko) {
            tulos.append(erotin);
            tulos.append(luku);
        }
        return tulos.substring(erotin.length());
    }
    

    private static int[] alusta(int koko) {
        int[] luvut = new int[koko];
        for (int i=0; i<luvut.length; i++)
            luvut[i] = i;
        return luvut;
    }
    
    
    
    @SuppressWarnings("javadoc")
    public static long alkuaika() {
        System.gc();
        return System.nanoTime();  
        
    }
    
    
    @SuppressWarnings("javadoc")
    public static void tulos(long startTime, String jonona, String testi) {
        long loppuaika = System.nanoTime();
        System.out.printf("%-15s pituus on %10d, ", testi, jonona.length());
        System.out.printf("aika = %5.2f\n", (loppuaika-startTime)/1e9);
    }
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        final int KOKO = 1000000;
        final int KOKO2 = 100000000;
        // String jonona;
        // long startTime;
        
        int[] luvut = alusta(KOKO);
        int[] luvut2 = alusta(KOKO2);


        tulos(alkuaika(), jonoksi(luvut, ",") ,  "jonoksi");
        
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        /*
        System.gc();
        long startTime = System.nanoTime();  
        String jonona = jonoksi(luvut2, ",");
        long loppuaika = System.nanoTime();
        System.out.printf("Pituus on %10d\n", jonona.length());
        System.out.println("Aika = " + (loppuaika-startTime)/1e9);
        */
        tulos(alkuaika(), jonoksi(luvut, ",", 7), "jonoksi n");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi2(luvut2, ","),  "jonoksi2");
        tulos(alkuaika(), jonoksi3(luvut2, ","),  "jonoksi3");
        tulos(alkuaika(), jonoksi4(luvut2, ","),  "jonoksi4");
        tulos(alkuaika(), jonoksi5(luvut2, ",") , "jonoksi5");
        
        tulos(alkuaika(), jonoksi(luvut, ",", 7), "jonoksi n");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi2(luvut2, ","),  "jonoksi2");
        tulos(alkuaika(), jonoksi3(luvut2, ","),  "jonoksi3");
        tulos(alkuaika(), jonoksi4(luvut2, ","),  "jonoksi4");
        tulos(alkuaika(), jonoksi5(luvut2, ",") , "jonoksi5");
    
        tulos(alkuaika(), jonoksi(luvut, ",", 7), "jonoksi n");
        tulos(alkuaika(), jonoksi(luvut2, ",") ,  "jonoksi");
        tulos(alkuaika(), jonoksi2(luvut2, ","),  "jonoksi2");
        tulos(alkuaika(), jonoksi3(luvut2, ","),  "jonoksi3");
        tulos(alkuaika(), jonoksi4(luvut2, ","),  "jonoksi4");
        tulos(alkuaika(), jonoksi5(luvut2, ",") , "jonoksi5");
    }
}
