/**
 * @file kuut.c
 * Esimerkki taulukkojen kytst
 *
 * @author Vesa Lappalainen
 * @version 27.4.2003
 */
#include <stdlib.h>
#include <stdio.h>


/**
 * Summataan taulukon kaikki alkiot
 * @param lkm taulukon alkioiden lkm
 * @param taulu taulukko jonka alkiot summataan
 * @return alkioden summa
 * @code
 * <pre name="test">
 *   int t[] = {1,2,3,4};
 *   taulukon_summa(4,t) === 10;
 * </pre>
 * @endcode */
int taulukon_summa(int lkm, int taulu[])
{
    int i;
    int summa = 0;
    for (i=0; i<lkm; i++)
        summa += taulu[i];
    return summa;
}


int main(void)
{
    /*  1. 2. 3. 4. 5. 6. 7. 8. 9.10.11.12 */
    int k_pituudet[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
    int *tammikuu,*helmikuu,*joulukuu,*p,i;

    int kuita = sizeof(k_pituudet)/sizeof(k_pituudet[0]);

    printf("Vuodessa on pivi %d.\n",taulukon_summa(kuita,k_pituudet));


    for (i=0; i<12; i++) k_pituudet[i]=0;
    tammikuu  = k_pituudet;
    helmikuu  = tammikuu+1;
    joulukuu  = k_pituudet+kuita-1;
    *tammikuu = 31;
    *helmikuu = 28;
    *joulukuu = 31;

    for (i=0, p=k_pituudet; i<kuita; i++, p++)
        *p=0;
    for (i=0, p=k_pituudet; i<kuita; i++)
        *p++=30;
    for (p=k_pituudet; p<k_pituudet+kuita; p++)
        *p=0;

    return 0;
}
